import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:example/models/badge/badge.dart';
import 'package:fireproof_annotation/fireproof_annotation.dart';
import 'package:flutter_fireproof/flutter_fireproof.dart';
import 'package:freezed_annotation/freezed_annotation.dart';

part 'user.fire.dart';
part 'user.freezed.dart';
part 'user.g.dart';

@freezed
class UserBase with _$UserBase {
  const factory UserBase({
    required String name,
    required String email,
  }) = _UserBase;

  factory UserBase.fromJson(Map<String, dynamic> json) =>
      _$UserBaseFromJson(json);
}

@fireproof
abstract class User with _$User {
  factory User({
    required UserBase data,
    required DocumentSnapshot snapshot,
  }) = _User;

  @Collection(name: 'badges')
  FireCollectionReference<BadgeBase, BadgeDoc> get badges;

  factory User.fromSnapshot(DocumentSnapshot snapshot) =>
      _$UserFromSnapshot(snapshot);
}
